#ifndef __VST_PLUGIN_H__
#define __VST_PLUGIN_H__

#include "aeffectx.h"
#include <windows.h>

typedef AEffect* (*VstPluginEntryProc) (audioMasterCallback audioMaster);

//-------------------------------------------------------------------------------------------------------
// CVstPluginLoader
//-------------------------------------------------------------------------------------------------------
struct CVstPluginLoader
{
//-------------------------------------------------------------------------------------------------------
	void* module;

	CVstPluginLoader ()
	: module (0)
	{}

	~CVstPluginLoader ()
	{
		if (module)
		{
			FreeLibrary ((HMODULE)module);
		}
	}

	bool loadLibrary (LPCTSTR fileName)
	{
		module = LoadLibrary (fileName);
		return module != 0;
	}

	VstPluginEntryProc getMainEntry ()
	{
		VstPluginEntryProc mainProc = 0;
		mainProc = (VstPluginEntryProc)GetProcAddress ((HMODULE)module, "VSTPluginMain");
		if (!mainProc)
			mainProc = (VstPluginEntryProc)GetProcAddress ((HMODULE)module, "main");
		return mainProc;
	}
//-------------------------------------------------------------------------------------------------------
};

#endif//__VST_PLUGIN_H__